/*********** include **************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "/home/home2/kitsune/include/XRSver1.h"


/*********** define ***************/

#define f(u)        (-u+0.5*(tanh((u-a)/delta)+tanh(a/delta)))
#define integer(x)  ((int)(floor(x)+floor(2*((x)-floor(x)))))


/*********** global variable ************/

double                  t;
double                  u[MAX];
double                  v[MAX];

double                  LX;
double                  DT,DX;
double                  time_interval;
double                  quit_time;

double                  a;
double                  D;
double                  delta;
double                  r_start;
double                  u_start;

int                     i_max,j_max;
int                     changedisp;

/********** function & class prototype *****************/

void                    initial(int);
void                    win_draw();
XRS                     X;

main()
{

     int step,disp_step,quit_step;

/*----- parameter input -----*/

     quit_time=10000.0;

     LX=500;
     DT=0.05;
     DX=0.5;
     a=0.2;
     delta=0.05;
     D=0.1;
     r_start=5.0;
     u_start=2.5;
     changedisp=0;

     i_max = (int)(LX/DX)+1;
     j_max = 100;

     time_interval=DT;
     disp_step=integer(time_interval/DT);
     quit_step=integer(quit_time/DT);


/*----- initialize ----------*/

     X<<EVENT    <<initial
                 <<"initial"
      <<PARAMETER<<a<<D<<delta<<u_start<<r_start
                 <<"a"<<"D"<<"delta"<<"u_start"<<"r_start"
      <<WINDOW(0)<<i_max<<j_max
                 <<"u"<<PX(1)
      <<WINDOW(1)<<i_max<<j_max
                 <<"v"<<PX(1);

     X.initialize(t);

     initial(0);

/*----- main routine --------*/

     while(1){

         register ts;
      
         X.checkevent();

         double   v2[MAX],u2[MAX];
         double   du,dv,txx;
         txx=DT/(DX*DX);

 
         for(ts=0; ts<disp_step; ts++){

             register i;
 
             for(i=1;i<i_max;i++){
                  du=u[i-1]+u[i+1]-2.0*u[i]; 
                  u2[i]=u[i]+txx*du+DT*(f(u[i])-v[i]);
             }

             for(i=1;i<i_max;i++){
                  dv=v[i-1]+v[i+1]-2.0*v[i];
                  v2[i]=v[i]+txx*D*dv+DT*u[i];
             }

             for(i=1;i<i_max;i++){
                     v[i]=v2[i];
                     u[i]=u2[i];
             }
             
             v[0]=v[1];
             v[i_max]=v[i_max-1];
             u[0]=u[1];
             u[i_max]=u[i_max-1];

         }

         t = t + time_interval;

         step=integer(t/DT);
         if(step >= quit_step) break;

         win_draw();

    }
}


/*************** initialize function ************/

void initial(int n)
{
    register i;
    double xi;

    t=0;

    for(i=0; i<i_max+1; i++){
       u[i] = 0.0;
       v[i] = 0.0;
    }

    for(i=0; i<i_max; i++)
       if(fabs((double)i-(double)i_max/2)<(r_start/DX)) u[i] = u_start;
}


//************** window draw **************

void win_draw(void)
{
    register int i;
    int jj[MAX];

    for(i=0; i<i_max+1; i++)
       jj[i]=(int)((double)j_max*(0.25+0.7*u[i]/u_start));
    X.point_draw(jj);
            
    for(i=0; i<i_max+1; i++)
       jj[i]=(int)((double)j_max*(0.25+0.7*v[i]/u_start));
    X.point_draw(jj,1,7);
}



